Subject: bug#36894: Restore frameset focus and selectedness

From: Juri Linkov <[email-masked]>
Date: Sun, 11 Aug 2019 23:51:54 +0300

retitle 36894 Restore frameset focus and selectedness
thanks

>> Then created a completely new desktop in Emacs 26,
>> but it didn't restore focus in the frame where it previously was.
>>
>> And I don't see how Emacs 26 could restore focus,
>
> Well, it does for me, and I think that's because the order of saving
> the frames is such that the selected frame is saved last (and thus
> restored last).
>
>> 'last-focus-update' was added recently in Emacs 27.
>
> How is that relevant?

'last-focus-update' could be used to put focus back to the same frame
where it was before saving the desktop.

>> So this is a new feature that we could use now in the desktop
>> to restore focus in the same frame where it was before.
>
> Selected frame and frame that has focus is not the same thing,
> definitely not with an arbitrary window-manager.

Maybe then the desktop should save the selectedness as well.
I see some ‘(selected . t)’ in the desktop, but it seems
these indicate the selected buffer, not frame.

> But I asked for a reproducible recipe, and I don't think you have
> shown one.  Could you please do that?  I'd like to study it.

In your case above, if you save the frames is such order that
the selected frame is not saved last, can you reproduce the problem?
I see this problem often when the last frame is not selected.